;----------------------------------------------------------------------------------------------------------------------------------------------------------
;                   LOOK FOR THE COOL MACRO AT THE END OF THIS PAGE !!!
;----------------------------------------------------------------------------------------------------------------------------------------------------------
;KillEntry Procedure
;-Removes an entry from a Linked-List.
;-Revised to handle parent-child and/or sibling links.
;-Examines Parent<--<THIS>-->Child links and
;-Patches- Parent<-->Child (Bypassing Self).
;-Examines OlderSibling<--<THIS>--YoungerSibling links and
;-Patches- OlderSibling<-->YoungerSibling (Bypassing Self).
;-Also detects and patches NewRoot and NewLast nodes.
;-Releases the allocated memory used by the killed entry.
;-In other words, flawless and transparent removal
;-of a single entry in our List.
;-------------------------------------------------------------------
KillEntry PROC lpThis:ptr LINKEDOBJECT     ;pointer to entry to be deleted
    push edi
    push esi
    invoke KillName, lpThis                           ;Kill any Name for this node
    mov edi, lpThis
    assume edi:LPLINKEDOBJECT
    .if [edi].pParent != NULL  ;I have a Parent and thus am not Root..
        .if [edi].pChild != NULL              ;..and I also have a Child..
            mov esi, [edi].pParent            ;(fetch ParentPointer)
            assume esi:LPLINKEDOBJECT
            mov eax, [edi].pChild             ;(fetch ChildPointer)
            mov [esi].pChild, eax             ;link Parent to Child, bypassing me
            mov esi, [edi].pChild             ;(ChildPointer)      
            mov eax, [edi].pParent             ;(ParentPointer)
            mov [esi].pParent, eax             ;link Child to Parent, bypassing me
        .else                                               ;..and I have no Child..
            mov esi, [edi].pParent
            mov [esi].pChild,NULL             ;Kill Parent's link to me
        .endif
    .endif    
        ;----------
    .if [edi].pOlderSibling != NULL
        .if [edi].pYoungerSibling !=NULL  ;..and I have a younger sibling
            mov esi, [edi].pOlderSibling      ;Fetch Mah Daddy     
            mov eax,[edi].pYoungerSibling ;Fetch Mah Kiddy
            mov [esi].pYoungerSibling,eax ;Tell Daddy about Kiddy
            mov esi,eax                                ;<-set to Kiddy
            mov [esi].pOlderSibling,eax  ;Tell Kiddy about Daddy
        .else                                               ;..I have no younger sibling..
            mov esi, [edi].pOlderSibling
            mov [esi].pYoungerSibling,NULL     ;Kill Parent's link to me
       .endif                                            ;(setting it as Last)
    .else                                                 ;I am Root and have no Parent..
        .if [edi].pChild != NULL              ;..but I do have a Child
            mov esi,  [edi].pChild
            mov [esi].pParent,NULL           ;Kill Child's link to Parent
        .endif                                            ;(setting it as Root)
        .if [edi].pYoungerSibling != NULL    ;..but I do have a Child
            mov esi,  [edi].pYoungerSibling
            mov [esi].pOlderSibling,NULL     ;Kill Child's link to Parent
        .endif                                            ;(setting it as Root)
    .endif   

    ; (no parent and no child? alone? nothing to repair then)
    mov eax,[edi].hLock  
    invoke GlobalUnlock,eax     
    mov eax,[edi].hLock       
    invoke GlobalFree,eax          
    pop esi
    pop edi
    assume esi:nothing
    assume edi:nothing
    return TRUE                                           ;cya
KillEntry ENDP

;----------------------------------------------------------------------------------------------------------------------------------------------------------

