;=====================================================================
LPMESHNODE typedef ptr MeshNode
MeshNode_GenerateMesh PROTO pThis:LPMESHNODE

;=====================================================================
;A silly but nonetheless handy macro which does not restore or repair Stack so beware
;=====================================================================
Errr MACRO p1:REQ
    invoke MessageBox,0,p1,CTXT("Error!"),MB_OK
    return E_FAIL
ENDM
;=====================================================================
;MeshNode_Create
;MeshNode_GenerateMesh
;MeshNode_Render
;MeshNode_Destroy
;MeshNode_FindBones
;=====================================================================================
;The CMeshNode Class from CPP...
;We'll call it MeshNode.
;These are the mesh nodes nested in our Frame nodes.
;=====================================================================================
MeshNode STRUCT
    LO LinkedObject <>
;	// mesh variables
	pD3DXSkinMesh    LPD3DXSKINMESH ?	;< Pointer to the D3DX skin mesh
	pD3DXBlendedMesh   LPD3DXMESH  ? 	;< Pointer to the blended version
	pAdjacency                   DWORD ?       	;< The adjacency array
;	// materials
	pMeshMaterials            DWORD ?		;< Pointer to the array of material structs
	pMeshTextures             DWORD ?      	;< The array of pTexture dwords
	dwNumMaterials           DWORD ?		;< The number of materials
;	// skinning info
	dwAttrCount                   DWORD  ?                 ;< The attribute count
            dwMaxFaceInfluence    DWORD ?	            ;< Maximum face influence
	pBoneMatrix                 LPD3DXMATRIX  ?	;< Bones' matrices array
	pBoneNamesBuf          LPD3DXBUFFER ?	;< Bones' names buffer
	pBoneOffsetMatrix        LPD3DXMATRIX ?	;< Bones' offset matrices
	pBoneCombinationBuf LPD3DXBUFFER ?     ;< Bone combinations buffer
MeshNode ENDS
LPMESHNODE typedef ptr MeshNode
;=====================================================================================

;=====================================================================================
MeshNode_Create PROC pThis:ptr MeshNode, pxofobj:ptr
local pmaterialsbuf:LPD3DXBUFFER
local axmaterial:LPD3DXMATERIAL 
local padjacencybuf:LPD3DXBUFFER 
local pboneoffsetbuf:LPD3DXBUFFER
local pbones:ptr
local padjacencyin:ptr
local pname:ptr
local dwnamelength:DWORD 
local dwfacescount:DWORD
local dwnumbones:DWORD
local buffysize:DWORD
local UrMomma:DWORD
local namebuf[256]:BYTE
local ErrBuf[256]:BYTE
;=====================================================================================
xor eax,eax
mov pboneoffsetbuf,eax
mov padjacencyin,eax
mov padjacencybuf,eax
mov pmaterialsbuf,eax
.if pThis==NULL
           Errr CTXT("Null Parent when creating MeshNode")
.endif
push esi                                                ;shove esi on the Stack for the remainder of this procedure
mov esi,pThis                                       ;(and this is why - we're going to use it as our "object pointer")
assume esi:LPMESHNODE

 ;=====================================================================================
 ; ;*** Assume that the MeshNode was named when it was created ***
 ;=====================================================================================

;*** load the mesh ***
invoke D3DXLoadSkinMeshFromXof, pxofobj, D3DXMESH_MANAGED, lpd3dDevice , addr padjacencybuf, 
addr pmaterialsbuf, addr [esi].dwNumMaterials, addr [esi].pBoneNamesBuf, addr pboneoffsetbuf, addr [esi].pD3DXSkinMesh 
.if eax!=D3D_OK
    pop esi
    Errr CTXT( "Couldn't load skin mesh" )
.endif
mov dwfacescount , $mcall ([esi].pD3DXSkinMesh,ID3DXSkinMesh_GetNumFaces)
mov dwnumbones , $mcall ([esi].pD3DXSkinMesh,ID3DXSkinMesh_GetNumBones)

push esi
invoke wsprintf,addr ErrBuf,CTXT("SkinMesh Geometry consists of:",13,10,"%lu Faces",13,10,"%lu Bones",13,10,"%lu Materials"),dwfacescount ,dwnumbones,[esi].dwNumMaterials
invoke MessageBox,0,addr ErrBuf,CTXT("LOADED SKINMESH GEOMETRY"),MB_OK
pop esi
;=====================================================================================
.if dwnumbones>0      ;*** IF BONES ARE FOUND, FETCH BONE INFO AND CONVERT SKINMESH TO BLENDED MESH
            mov eax,dwnumbones
            mov ebx,sizeof D3DXMATRIX 
            mul ebx                                            ;Calculating size of BoneMatrices Buffer(s)
            mov buffysize,eax                           ;buffysize = "enough room for #BONES * sizeof one Matrix"

            mov eax,dwfacescount
            mov ebx,3*sizeof DWORD      
            mul ebx                                                ;Calculating size of Adjacency Index Buffer
            mov UrMomma,eax                             ;UrMomma = #faces * (3 dwords per face)
            mov [esi].pAdjacency,$invoke (GlobalAlloc, GPTR, UrMomma)               ;Allocate memory for Adjacency Buffer
            mov [esi].pBoneMatrix  ,         $invoke (GlobalAlloc, GPTR, buffysize)   ;Allocate memory for Bone Matrix Array
            mov [esi].pBoneOffsetMatrix ,$invoke (GlobalAlloc, GPTR, buffysize)   ;Allocate memory for Bone Offset Matrix Array

            mov pbones,          $mcall (pboneoffsetbuf,ID3DXBuffer_GetBufferPointer) ;Get access to the actual buffer data
	mov padjacencyin, $mcall (padjacencybuf,ID3DXBuffer_GetBufferPointer) ;for both these two buffers

	invoke RtlMoveMemory, [esi].pBoneOffsetMatrix, pbones, buffysize   ;Copy the BoneOffsetMatrices 
	invoke RtlMoveMemory, [esi].pAdjacency, padjacencyin, UrMomma      ;Copy Adjacency info

	invoke MeshNode_GenerateMesh, pThis                                    ;Convert SkinMesh to BlendedMesh

;=====================================================================================
.else       ;*** IF NO BONES ARE FOUND, BLEND THE MESH AND USE AS A STATIC MESH (NOT ANIMATED)
	mcall [esi].pD3DXSkinMesh,ID3DXSkinMesh_GetOriginalMesh,addr [esi].pD3DXBlendedMesh 
	_saferelease [esi].pD3DXSkinMesh
	m2m [esi].dwAttrCount , [esi].dwNumMaterials
.endif
;=====================================================================================
push esi
invoke MessageBox,0,CTXT("Your Mesh is Ready"),CTXT("Cool"),MB_OK
pop esi
;=====================================================================================
;=====================================================================================
;=====================================================================================
;=====================================================================================
;=====================================================================================
;THE FOLLOWING CODE IS EXECUTED WHETHER THE MESH HAS BONES OR NOT
;// check for materials
;=====================================================================================
;Case - Materials were NOT found
;=====================================================================================
.if( (pmaterialsbuf == NULL) || ( [esi].dwNumMaterials== 0)) ;** IF no materials are found, create a default material
		mov [esi].pMeshMaterials , $invoke (GlobalAlloc, GPTR, sizeof D3DMATERIAL8)
		mov [esi].dwNumMaterials,1
		mov [esi].pMeshTextures,NULL

		invoke RtlZeroMemory, [esi].pMeshMaterials,  sizeof D3DMATERIAL8
                        mov ebx,[esi].pMeshMaterials
                        assume ebx:ptr D3DMATERIAL8
                        fld fphalf
                        fst  [ebx].Diffuse.r
                        fst  [ebx].Diffuse.g
                        fst  [ebx].Diffuse.b
                        fst  [ebx].Specular.r
                        fst  [ebx].Specular.g
                        fst  [ebx].Specular.b
                        assume ebx:nothing
;=====================================================================================
;Case - One or more Materials have been found and must be processed...
;=====================================================================================
.else		;** IF Materials were found, we will load them
                        mov eax,sizeof D3DMATERIAL8
                        mul  [esi].dwNumMaterials        
		mov [esi].pMeshMaterials, $invoke (GlobalAlloc, GPTR,EAX)
                        push esi
                        mov ebx,[esi].dwNumMaterials        
                        shl ebx,2                        
                        push ebx
		mov [esi].pMeshTextures,  $invoke (GlobalAlloc, GPTR,ebx)
                        pop ebx
                        pop esi
		invoke RtlZeroMemory, [esi].pMeshTextures,ebx
                        push esi
                        invoke MessageBox,0,CTXT("Materials and Textures buffers were allocated"),CTXT("Looking Good"),MB_OK
		mov axmaterial , $mcall ([pmaterialsbuf],ID3DXBuffer_GetBufferPointer)
                        invoke MessageBox,0,CTXT("Got Pointer to Materials Buffer"),CTXT("Looking Good"),MB_OK
                        pop esi

;		for( int i = 0; i < dwMaterialCount; i++ )
                        mov ecx,0
                        push esi

                        .while ecx<[esi].dwNumMaterials
		      push ecx                                                                ;(preserve loop counter during loop)

                              push esi
                              mov edi,[esi].pMeshMaterials                               ;theres a subtle difference between these
                              mov esi,axmaterial                                                ;Calculate source and destination

                              mov ebx,sizeof D3DXMATERIAL                         ;for copying the current Material
                              imul ebx,ecx                                                          ;note that we are copying from
                              add esi,ebx                                                           ;a D3DXMATERIAL into a D3DMATERIAL
                              mov ebx,sizeof D3DMATERIAL8                           ;Do you know what it is?
                              imul ebx,ecx
                              add edi,ebx                       ;    aMaterial[i] = axmaterial[i].MatD3D = Copy one material [i]
                              assume esi:LPD3DXMATERIAL
                              m2m pname, [esi].pTextureFilename    
                              assume esi:nothing
                              invoke RtlMoveMemory, edi, esi, sizeof D3DMATERIAL8    
                                           invoke wsprintf,addr namebuf,CTXT("Try to load %s"), pname
                                           invoke MessageBox,0,addr namebuf,CTXT("TEXTURE LOADER"),MB_OK
                              pop esi    
                              mov esi,pThis
      ;** DOES This Material require a Texture to be loaded ?? Huh? Huh? Does it ??
		       .if pname != NULL 	;YES so load the texture
                                     pop ecx           
                                      assume esi:LPMESHNODE           
                                     push ecx
                                     shl ecx,2
                                     mov esi,[esi].pMeshTextures
                                     add esi,ecx                            
 			 invoke D3DXCreateTextureFromFileEx, lpd3dDevice, pname,
			 D3DX_DEFAULT, D3DX_DEFAULT,D3DX_DEFAULT, 0, D3DFMT_UNKNOWN, D3DPOOL_MANAGED,
                                     D3DX_DEFAULT, D3DX_DEFAULT, 0, NULL, NULL, esi
			.if eax!=D3D_OK                                           
                                           invoke wsprintf,addr namebuf,CTXT("Could not load %s"), pname
                                           pop ecx                      ;**repair Stack **
                                           pop esi
                                           pop esi
                                           lea eax,namebuf
    			       Errr EAX  
                                    .else
                                           invoke wsprintf,addr namebuf,CTXT("W00T - Texture =  %s"), pname
                                           invoke MessageBox,0,addr namebuf,CTXT("TEXTURE LOADED"),MB_OK
			.endif
		        .else
                                     pop ecx           
                                     pop esi
                                     push esi                                                             
                                     push ecx
                                     shl ecx,2
                                     assume esi:LPMESHNODE    
                                     lea esi,[esi].pMeshTextures
                                     add esi,ecx     
			 mov dword ptr[esi] , NULL 
                                .endif
                                pop ecx                             ;** RESTORE LoopCounter
                                inc ecx                               ; and increment it for the next Material
		.endw                                        ;and LOOP until we have processed ALL MATERIALS

                        pop esi
;=====================================================================================
.endif                                                    ;(no more cases)
;=====================================================================================
_saferelease padjacencybuf 
_saferelease pmaterialsbuf 
_saferelease pboneoffsetbuf 
;=====================================================================================
invoke MessageBox,0,CTXT("AWESOME"),CTXT("MESHNODE CREATED"),MB_OK
;=====================================================================================
pop esi
return S_OK
MeshNode_Create ENDP
;=================================================================================
;=================================================================================
;=================================================================================
;=================================================================================
;This procedure Generates the Blended Mesh to be used by the rendering function.
;It attempts to convert the existing SKINMESH :)
;=================================================================================
MeshNode_GenerateMesh PROC pThis:LPMESHNODE
local padjacencyin:ptr
local dwfacecount, sizAdj:DWORD
local ErrBuf[256]:BYTE

.if pThis==NULL
    Errr CTXT("MORON tried to Generate NULL MESHNODE OBJECT")
.endif
push esi
mov esi,pThis
assume esi:LPMESHNODE
.if [esi].pD3DXSkinMesh==NULL
    pop esi
    Errr CTXT("MORON tried to Generate NULL pD3DXSkinMesh IN MESHNODE OBJECT")
.endif

mov dwfacecount, $mcall ([esi].pD3DXSkinMesh,ID3DXSkinMesh_GetNumFaces)
 mov ebx,3*4
mul ebx
mov sizAdj,eax
mov padjacencyin , $invoke (GlobalAlloc,GPTR, sizAdj)                      ;Allocate buffer for Adjacency info

push esi
invoke RtlMoveMemory, padjacencyin, [esi].pAdjacency, sizAdj      ;copy the adjacency buffer
pop esi


_saferelease [esi].pD3DXBlendedMesh             ;Release the defunct pD3DXBlendedMesh, if any
;*** BLEND the mesh
mcall [esi].pD3DXSkinMesh,ID3DXSkinMesh_ConvertToBlendedMesh, D3DXMESH_WRITEONLY, padjacencyin, [esi].pAdjacency, addr [esi].dwAttrCount, addr [esi].pBoneCombinationBuf, 0 , 0, addr [esi].pD3DXBlendedMesh 
push eax
invoke GlobalFree, padjacencyin                     ;Free the temp Adjacency buffer
mov padjacencyin,NULL
pop eax
.if eax!=D3D_OK
   pop esi
   Errr CTXT( "Couldn't convert SkinMesh to BlendedMesh")
.endif


; CALCULATE the max face influence count
mcall [esi].pD3DXBlendedMesh,ID3DXBaseMesh_GetFVF
and eax,  D3DFVF_POSITION_MASK
.if eax != D3DFVF_XYZ 
            sub eax,D3DFVF_XYZRHW
            shr eax,1
            inc eax
            mov [esi].dwMaxFaceInfluence ,eax  	; = ((EAX - D3DFVF_XYZRHW) / 2) +1;
.else
            mov [esi].dwMaxFaceInfluence , 1
.endif
invoke wsprintf,addr ErrBuf,CTXT("-= Converted SkinMesh to BlendedMesh =- ",13,10, "--Max Faces Influencing Vertices = %lu"), [esi].dwMaxFaceInfluence
invoke MessageBox,0,addr ErrBuf,CTXT("MeshNode_GenerateMesh"),MB_OK
pop esi
return S_OK
MeshNode_GenerateMesh ENDP
;=================================================================================
;=================================================================================
;=================================================================================
;=================================================================================
MeshNode_Render PROC pThis:LPMESHNODE
;=================================================================================
local ipattr, attrid , matid :DWORD
local abonecombination:LPD3DXBONECOMBINATION 
;=================================================================================
.if pThis==NULL
    mov OkToRender,FALSE
    Errr CTXT("MORON tried to Render NULL MESHNODE OBJECT")
.endif
push esi
mov esi,pThis
assume esi:LPMESHNODE
;=================================================================================
;	                                               check if we have a skin mesh or a normal mesh
;=================================================================================
.if [esi].pD3DXSkinMesh != NULL	
;		// CASE 1 of 2 - DRAWING A SKINMESH
;		// draw using non indexed blending
;		// assuming that the hardware can support the number of matrices
;		// let's begin this shit - get the bone combinations

		mov abonecombination , $mcall ([esi].pBoneCombinationBuf,ID3DXBuffer_GetBufferPointer)
;		// enable vertex blending
                        mov eax,[esi].dwMaxFaceInfluence
                        dec eax
		mcall [lpd3dDevice],IDirect3DDevice8_SetRenderState, D3DRS_VERTEXBLEND, eax 
                        xor ecx,ecx
                        mov ipattr,ecx
                        .while ecx<[esi].dwAttrCount		; for ipattr = 0; ipattr < dwAttrCount; ipattr++                           
;	                      Set the matrices for this attribute range			
                                    xor ecx,ecx
                                    .while ecx<[esi].dwMaxFaceInfluence      ;for i = 0; i < dwMaxFaceInfl; ++i 
                                                push ecx
                                                shl ecx,2                                                               ;BoneID's are in an array of dwords
                                                mov ebx,abonecombination
                                                mov eax,ipattr
                                                imul eax,sizeof D3DXBONECOMBINATION
                                                add ebx,eax                                                         ;pointing to BONECOMBINATION
                                                mov ebx,[ebx].D3DXBONECOMBINATION.BoneId       ;BoneId is a pointer to a dword array
                                                add ebx,ecx                                                         ;which dword? THAT one :)
				m2m matid , dword ptr[ebx]                                 ;copy it

                                                mov ebx,abonecombination
                                                mov eax,ipattr
                                                dec eax
                                                imul eax,sizeof D3DXBONECOMBINATION
                                                add ebx,eax                                                         ;pointing to BONECOMBINATION
                                                mov ebx,[ebx].D3DXBONECOMBINATION.BoneId       ;BoneId is a pointer to a dword array
                                                add ebx,ecx                                                         ;which dword? THAT one :)

                                                mov eax,matid
				.if eax != 65535 && (ipattr == 0 || eax != dword ptr[ebx] )
                                                            pop ebx
                                                            push ebx
                                                            mov ecx,ebx                                                            
                                                            imul ecx,sizeof D3DMATRIX
                                                            add ecx,[esi].pBoneMatrix
                                                            add ebx,256  ; D3DTS_WORLDMATRIX = transform index + 256
					mcall [lpd3dDevice],IDirect3DDevice8_SetTransform,ebx, ecx
                                                            mov ecx,matid
                                                            imul ecx,sizeof D3DMATRIX
					mcall [lpd3dDevice],IDirect3DDevice8_MultiplyTransform,ebx, addr [esi].pBoneOffsetMatrix[ecx]
				.endif
                                                pop ecx
                                                inc ecx
			.endw

;			// check if the material is different than that of the previous attribute
                                    mov ecx,ipattr
                                    imul ecx,sizeof D3DXBONECOMBINATION
                                    add ecx,abonecombination
                                    mov eax, [ecx].D3DXBONECOMBINATION.AttribId
                                    mov attrid,eax
                                    mov ebx,ecx
                                    sub ebx,sizeof D3DXBONECOMBINATION
                                    mov ebx,[ebx].D3DXBONECOMBINATION.AttribId
			.if ( ipattr == 0) || (EAX != EBX)			
        		                  ;// set the new material
                                                mov ebx, [esi].pMeshMaterials
                                                mov ecx,attrid
                                                imul ecx,sizeof D3DMATERIAL8
                                                add ebx,ecx
				mcall [lpd3dDevice],IDirect3DDevice8_SetMaterial, ebx
                                                mov ebx, [esi].pMeshTextures
                                                mov ecx,attrid
                                                shl ecx,2
                                                add ebx,ecx
				mcall [lpd3dDevice],IDirect3DDevice8_SetTexture, 0, dword ptr [ebx]
			.endif

			mcall [esi].pD3DXBlendedMesh,ID3DXBaseMesh_DrawSubset ,ipattr                           ;render
                                    inc ipattr
                                    mov ecx,ipattr
		.endw
	;	// rendering is finished, set the vertex blending back to disabled mode
		mcall [lpd3dDevice],IDirect3DDevice8_SetRenderState, D3DRS_VERTEXBLEND, 0 

;=================================================================================	
.else               ;CASE 2 of 2 - DRAWING A NORMAL UNSKINNED MESH
                       xor ecx,ecx
                       .while ecx<[esi].dwAttrCount
		      push ecx
                              mov ebx,[esi].pMeshMaterials
                              imul ecx,sizeof D3DMATERIAL8
                              add ebx,ecx
		       mcall [lpd3dDevice],IDirect3DDevice8_SetMaterial, ebx
                               pop ecx
                               push ecx
                               mov ebx,[esi].pMeshTextures
                               shl ecx,2
                               add ebx,ecx
		       mcall [lpd3dDevice],IDirect3DDevice8_SetTexture, 0, dword ptr[ebx]
                               pop ecx
                               push ecx
		       mcall [esi].pD3DXBlendedMesh,ID3DXBaseMesh_DrawSubset, ecx
                               pop ecx
                               inc ecx
                       .endw
.endif
pop esi
return S_OK
MeshNode_Render ENDP
;=================================================================================
;=================================================================================
;=================================================================================
; This procedure is used to DESTROY a MeshNode - it patches Links but does not destroy hierarchy
;=================================================================================
MeshNode_Destroy PROC pThis:LPMESHNODE
        .if pThis==NULL
            Errr CTXT("MORON TRIED TO DESTROY A NULL MESHNODE OBJECT")
        .else
            push esi
            mov esi,pThis
            assume esi:LPMESHNODE
	_saferelease [esi].pD3DXSkinMesh 
	_saferelease [esi].pD3DXBlendedMesh 
	_safefree [esi].pMeshMaterials
	.if [esi].pMeshTextures!=NULL	
                    xor ecx,ecx
                    .while ecx<[esi].dwNumMaterials
                        push ecx
                        shl ecx,2
                        add ecx,[esi].pMeshTextures
		_saferelease dword ptr[ecx]
		pop ecx
		inc ecx
                    .endw
	.endif
	_safefree [esi].pBoneMatrix 
	_safefree [esi].pBoneOffsetMatrix
	_safefree [esi].pAdjacency 
	_saferelease [esi].pBoneCombinationBuf 
	_saferelease [esi].pBoneNamesBuf
            invoke KillEntry, pThis                                         ;LinkedList - destroy THIS Node, patch Links
            pop esi
        .endif
        return S_OK
MeshNode_Destroy ENDP


;=========================================================================
; This procedure is used to Find the bones of a mesh object.
;prootframe : the root frame to start searching for frames
;=========================================================================
MeshNode_FindBones PROC pThis:ptr MESHNODE, prootframe:ptr FRAMENODE
local pframe:ptr FRAMENODE
local abonename:ptr
local numbones:DWORD

        .if prootframe==NULL
            Errr CTXT("MORON Tried to FindBones in a MeshNode of a NULL Frame")
        .endif

        .if pThis==NULL
            Errr CTXT ("MORON Tried to FindBones in a NULL MeshNode")
        .endif

        assume esi:nothing
        push esi
        mov esi,pThis
        assume esi:LPMESHNODE
        .if [esi].pD3DXSkinMesh==NULL
               pop esi
               return NULL
         .endif
                              ;*** GET the buffer containing the names of the bones
            mov abonename ,$mcall ([esi].pBoneNamesBuf,ID3DXBuffer_GetBufferPointer)
            mov numbones, $mcall ([esi].pD3DXSkinMesh,ID3DXSkinMesh_GetNumBones)
            xor ecx,ecx 
            .while ecx< numbones	 ;FOR ALL BONES,
	      push ecx		              ; find a frame with the same name
                   shl ecx,2                            ; *4 because array elements are dwords, not bytes
    	       mov pframe ,$invoke (FindEntryByName, prootframe, abonename[ecx] )
                    .if pframe!=0
                        mov ebx,pframe
                        lea eax,[ebx].FrameNode.CombinedMatrix
	            mov [esi].pBoneMatrix[ecx] , eax
                   .endif
	       pop ecx
                   inc ecx
            .endw
            pop esi
            return S_OK
MeshNode_FindBones ENDP
;=========================================================================
;=========================================================================
